// Modules utilisés
import geometry;

unitsize(1cm);

// Les oreilles
point D1=(3,-0.8), D2=(3.5,-1.2), G1=(-3,-0.8), G2=(-3.5,-1.2);
circle c1=circle(D1,1.5), c2=circle(D2,1.5), c3=circle(G1,1.5), c4=circle(G2,1.5);
// La tête
point T1=(0,-2.8);
circle ca=circle(T1,4), c5=circle(D2,7.5), c6=circle(G2,7.5);
point D=intersectionpoint(c1,ca), G=intersectionpoint(c3,ca);
point[] p=intersectionpoints(c5,c6);
point n=p[0];
circle cb=circle(n,1);
// Le corps
point B1=(-1.5,0.2);
circle c7=circle(B1,5);
// La queue
point Q1=(2,4.5), Q2=(0.5,4.5);
circle c8=circle(Q1,6.5), c9=circle(Q2,3.4);
point Q3=point(c8,0), Q4=point(c9,0);
circle c10=circle(Q3,Q4);
// Les yeux
point Y1=(1.5,-4.2), Y2=(-1.5,-4.2);
circle y1=circle(Y1,0.2), y2=circle(Y1,0.4), y3=circle(Y1,0.6), y4=circle(Y2,0.2), y5=circle(Y2,0.4), y6=circle(Y2,0.6);

// Les yeux
currentpen=currentpen+1bp;
filldraw((path)y2,grey,grey);
filldraw((path)y1,white,grey);
draw(y3);
filldraw((path)y5,grey,grey);
filldraw((path)y4,white,grey);
draw(y6);

// Les points utilisés pour le tracé, repérés par des croix
marker croix=marker(scale(2)*cross(4));
draw("$D_1$",D1,NE,croix);
draw("$D_2$",D2,NE,croix);
draw("$G_1$",G1,NW,croix);
draw("$G_2$",G2,NW,croix);
draw("$T_1$",T1,N,croix);
draw("$D$",D,N,croix);
draw("$G$",G,N,croix);
draw("$N$",n,S,croix);
draw("$B_1$",B1,NE,croix);
draw("$Q_1$",Q1,SE,croix);
draw("$Q_2$",Q2,SW,croix);
draw("$Q_3$",Q3,SE,croix);
draw("$Q_4$",Q4,SW,croix);

// tracé à blanc pour l'ajustement du cadre
currentpen=nullpen;

// Oreille droite
draw(c1);
draw(arc(c2,intersectionpoints(c1,c2)[0],intersectionpoints(c1,c2)[1],CW));

// Oreille gauche
draw(c3);
draw(arc(c4,intersectionpoints(c3,c4)[0],intersectionpoints(c3,c4)[1],CCW));

// Haut de la tête
draw(arc(ca,intersectionpoints(ca,c1)[1],intersectionpoints(ca,c3)[1],CCW));

// Joue gauche
draw(arc(c5,intersectionpoints(c5,c6)[0],intersectionpoints(c5,c3)[0],CW));

// Jour droite
draw(arc(c6,intersectionpoints(c5,c6)[0],intersectionpoints(c6,c1)[0],CCW));

// Truffe
draw(arc(cb,intersectionpoints(cb,c6)[1],intersectionpoints(cb,c5)[1],CCW));

// Corps
draw(arc(c7,intersectionpoints(c7,c5)[0],intersectionpoints(c7,c1)[1],CW));

// Queue 1/3
draw(arc(c8,intersectionpoints(c8,c7)[1],Q3,CW));

// Queue 2/3
draw(arc(c9,intersectionpoints(c9,c7)[1],Q4,CW));

// Queue 3/3
draw(arc(c10,Q4,Q3,CCW));

shipout(prefix="PatronLoir",bbox(5mm,nullpen),"pdf");
